/*************************************************************************/
/*************************************************************************/
/* H. Timucin OZDEMIR                                                    */
/* Date : March, 1997                                                    */
/* File Name : trianMF.cc                                                */
/*************************************************************************/
/*************************************************************************/

#include "trianMF.h"
#include "../deffunc.h"
#include "Function.h"
#include "XtrianMF.h"

trianMF::trianMF(float a, float b, float c)
{  int i,j;
   float k[3], va;

   k[0]=a; k[1]=b; k[2]=c;

   for(i=0;i<2;i++)
     for(j=i+1;j<3;j++)
      if(k[i]>k[j])
      {  va=k[i];
	 k[i] = k[j];
	 k[j] = va;
      }

     Left = k[0]; 
   center = k[1]; 
    Right = k[2]; 

   cutOff = 1.0;
}// end of constructor

trianMF::setLeftBorder(float _newValue)
{  int ok=0;
   if(_newValue>center) ok=0;
   else Left = _newValue;
   return ok;
}// end of setLeftBorder()

trianMF::setCenter(float _newValue)
{  int ok=0;
   if(_newValue>Right || _newValue<Left) ok=0;
   else Left = _newValue;
   return ok;
}// end of setCenter()

trianMF::setRightBorder(float _newValue)
{  int ok=0;
   if(_newValue<center) ok=0;
   else Left = _newValue;
   return ok;
}// end of setRightBorder()

float trianMF::getLeftBorder() const { return Left; }

float trianMF::getCenter() const { return center; }

float trianMF::getRightBorder() const { return Right; }

float trianMF::getValue(float x) 
{  float ret; 
   ret= maximum(minimum((x-Left)/(center-Left),(Right-x)/(Right-center)),0); 
   return minimum(ret,cutOff);
}// end of getValue()

Function *trianMF::Xversion()  
{  XtrianMF *ret= new XtrianMF(Left,center,Right);
   (*ret).setCutOff(cutOff);
   return ret;
}// end of Xversion()

Function *trianMF::getMyTwin()  
{  trianMF *ret= new trianMF(Left,center,Right);
   (*ret).setCutOff(cutOff);
   return ret;
}// end of getMyTwin()

ostream& operator<<(ostream& os, const trianMF& RHS)
{  os << " Triangle(" << RHS.Left << "," << RHS.center << ",";
   os << RHS.Right << ") with " << RHS.cutOff;
   return os;
}// end of operator<<
    
void trianMF::printOn(ostream& os) const {  os<<(*this); }


